# Class VulkanLogicalDeviceQueueCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanLogicalDeviceQueueCreateInfo

All Implemented Interfaces:
  `VulkanLogicalDeviceQueueCreateInfoType`

public final class VulkanLogicalDeviceQueueCreateInfo extends Object implements VulkanLogicalDeviceQueueCreateInfoType
The information required to create a queue on a device.

See Also:
  - "VkDeviceQueueCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanLogicalDeviceQueueCreateInfo.Builder`
  Builds instances of type `VulkanLogicalDeviceQueueCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanLogicalDeviceQueueCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanLogicalDeviceQueueCreateInfo`.
  `static VulkanLogicalDeviceQueueCreateInfo`
  `copyOf(VulkanLogicalDeviceQueueCreateInfoType instance)`
  Creates an immutable copy of a `VulkanLogicalDeviceQueueCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanLogicalDeviceQueueCreateInfo` that have equal attribute values.
  `Set<VulkanDeviceQueueCreationFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `queueFamilyIndex`, `queuePriorities`.
  `static VulkanLogicalDeviceQueueCreateInfo`
  `of(Iterable<VulkanDeviceQueueCreationFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex, Iterable<Float> queuePriorities)`
  Construct a new immutable `VulkanLogicalDeviceQueueCreateInfo` instance.
  `static VulkanLogicalDeviceQueueCreateInfo`
  `of(Set<VulkanDeviceQueueCreationFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex, List<Float> queuePriorities)`
  Construct a new immutable `VulkanLogicalDeviceQueueCreateInfo` instance.
  `VulkanQueueFamilyIndex`
  `queueFamilyIndex()`
  `List<Float>`
  `queuePriorities()`
  Set the priorities of the created queues.
  `String`
  `toString()`
  Prints the immutable value `VulkanLogicalDeviceQueueCreateInfo` with attribute values.
  `final VulkanLogicalDeviceQueueCreateInfo`
  `withFlags(VulkanDeviceQueueCreationFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanLogicalDeviceQueueCreateInfo`
  `withFlags(Iterable<VulkanDeviceQueueCreationFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanLogicalDeviceQueueCreateInfo`
  `withQueueFamilyIndex(VulkanQueueFamilyIndex value)`
  Copy the current immutable object by setting a value for the `queueFamilyIndex` attribute.
  `final VulkanLogicalDeviceQueueCreateInfo`
  `withQueuePriorities(float... elements)`
  Copy the current immutable object with elements that replace the content of `queuePriorities`.
  `final VulkanLogicalDeviceQueueCreateInfo`
  `withQueuePriorities(Iterable<Float> elements)`
  Copy the current immutable object with elements that replace the content of `queuePriorities`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jcoronado.api.VulkanLogicalDeviceQueueCreateInfoType

  `checkPreconditions`

- ## Method Details

  - ### flags

    public Set<VulkanDeviceQueueCreationFlag> flags()
    Specified by:
      `flags` in interface `VulkanLogicalDeviceQueueCreateInfoType`
    Returns:
      The flags used to create the queue(s)

  - ### queueFamilyIndex

    public VulkanQueueFamilyIndex queueFamilyIndex()
    Specified by:
      `queueFamilyIndex` in interface `VulkanLogicalDeviceQueueCreateInfoType`
    Returns:
      The queue family

  - ### queuePriorities

    public List<Float> queuePriorities()
    Set the priorities of the created queues. The number of priority values set will implicitly set the number of queues to create.
    Specified by:
      `queuePriorities` in interface `VulkanLogicalDeviceQueueCreateInfoType`
    Returns:
      The priorities of the queues

  - ### withFlags

    public final VulkanLogicalDeviceQueueCreateInfo withFlags(VulkanDeviceQueueCreationFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanLogicalDeviceQueueCreateInfo withFlags(Iterable<VulkanDeviceQueueCreationFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueueFamilyIndex

    public final VulkanLogicalDeviceQueueCreateInfo withQueueFamilyIndex(VulkanQueueFamilyIndex value)
    Copy the current immutable object by setting a value for the `queueFamilyIndex` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for queueFamilyIndex
    Returns:
      A modified copy of the `this` object

  - ### withQueuePriorities

    public final VulkanLogicalDeviceQueueCreateInfo withQueuePriorities(float... elements)
    Copy the current immutable object with elements that replace the content of `queuePriorities`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueuePriorities

    public final VulkanLogicalDeviceQueueCreateInfo withQueuePriorities(Iterable<Float> elements)
    Copy the current immutable object with elements that replace the content of `queuePriorities`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of queuePriorities elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanLogicalDeviceQueueCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `queueFamilyIndex`, `queuePriorities`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanLogicalDeviceQueueCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanLogicalDeviceQueueCreateInfo of(Set<VulkanDeviceQueueCreationFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex, List<Float> queuePriorities)
    Construct a new immutable `VulkanLogicalDeviceQueueCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queueFamilyIndex` - The value for the `queueFamilyIndex` attribute
      `queuePriorities` - The value for the `queuePriorities` attribute
    Returns:
      An immutable VulkanLogicalDeviceQueueCreateInfo instance

  - ### of

    public static VulkanLogicalDeviceQueueCreateInfo of(Iterable<VulkanDeviceQueueCreationFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex, Iterable<Float> queuePriorities)
    Construct a new immutable `VulkanLogicalDeviceQueueCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queueFamilyIndex` - The value for the `queueFamilyIndex` attribute
      `queuePriorities` - The value for the `queuePriorities` attribute
    Returns:
      An immutable VulkanLogicalDeviceQueueCreateInfo instance

  - ### copyOf

    public static VulkanLogicalDeviceQueueCreateInfo copyOf(VulkanLogicalDeviceQueueCreateInfoType instance)
    Creates an immutable copy of a `VulkanLogicalDeviceQueueCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanLogicalDeviceQueueCreateInfo instance

  - ### builder

    public static VulkanLogicalDeviceQueueCreateInfo.Builder builder()
    Creates a builder for `VulkanLogicalDeviceQueueCreateInfo`.

         VulkanLogicalDeviceQueueCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanDeviceQueueCreationFlag) // flags elements
            .setQueueFamilyIndex(com.io7m.jcoronado.api.VulkanQueueFamilyIndex) // required queueFamilyIndex
            .addQueuePriorities|addAllQueuePriorities(float) // queuePriorities elements
            .build();

    Returns:
      A new VulkanLogicalDeviceQueueCreateInfo builder